//+------------------------------------------------------------------+
//|                                                   WoodiesCCI.mq4 |
//|                                                            thorr |
//|                                          modded by Mediator      |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "histogram colour update by thor@gmx.co.uk Moneytec chat: thorr; created by Luis Damiani; converted by Rosh; modded by Mediator"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Black
#property indicator_width1 2
#property indicator_color2 Black
#property indicator_width2 2
#property indicator_color3 Yellow
#property indicator_width3 4
#property indicator_color4 Red
#property indicator_width4 2
#property indicator_color5 Blue
#property indicator_width5 2
//---- input parameters
extern double       A_period=8;
 int       B_period=8;
 int       neutral = 0;
extern int       num_bars=1000;
extern bool UseAlert = false;
extern bool UseEmail = false;
// parameters
int i=0;
bool initDone=true;
int bar=0;
int prevbars=0;
int startpar=0;
int cs=0;
int prevcs=0;
string commodt="nonono";
int frame=0;
int bars=0;

int count = 0, thisbar = 0;
double now, prev;
bool flag;

//---- buffers
double FastWoodieCCI[];
double SlowWoodieCCI[];
double HistoWoodieCCI[];
double HistoRed[];
double HistoBlue[];
datetime dt;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,FastWoodieCCI);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,SlowWoodieCCI);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,HistoWoodieCCI);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,HistoRed);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4,HistoBlue);
   IndicatorShortName("+");
//----
   return(0);
 
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();

   cs = A_period + B_period + num_bars; //checksum used to see if parameters have been changed

   if ((cs==prevcs) && (commodt == Symbol()) && 
      (frame == (Time[4] - Time[5])) &&
      ((Bars - prevbars) < 2))
      startpar = Bars - prevbars; 
   else 
      startpar = -1;  //params haven't changed only need to calculate new bar

   commodt = Symbol();
   frame= Time[4] - Time[5];
   prevbars = Bars;
   prevcs = cs;

   if (startpar == 1 | startpar == 0)  
      bar = startpar;
   else 
      initDone = true;

   if (initDone) {
      //FastWoodieCCI[num_bars-1]=0;
      SlowWoodieCCI[num_bars-1]=0;
      HistoWoodieCCI[num_bars-1]=0;
      HistoBlue[num_bars-1]=0;
      HistoRed[num_bars-1]=0;
      bar=num_bars-2;
      initDone=false;
   }

   for (i = bar; i >= 0; i--) {
      //FastWoodieCCI[i]=iCCI(NULL,0,B_period,PRICE_TYPICAL,i);
      //SlowWoodieCCI[i]=iCCI(NULL,0,A_period,PRICE_TYPICAL,i);
      
      now = iCCI(NULL,0,A_period,PRICE_TYPICAL,i);

      if ((prev >= 0 && now < 0) || (prev < 0 && now >= 0))
      { // change of sign detected
         
         
         HistoWoodieCCI[i] = now;
         HistoBlue[i] = EMPTY_VALUE;
         HistoRed[i] = EMPTY_VALUE;
         prev = now;
        
      } else
      {
      
      // Colour it!
         if (now > 0)
         {
            HistoBlue[i] = now;
            HistoWoodieCCI[i] = EMPTY_VALUE;
         }
         if (now < 0)
         {
            HistoRed[i] = now;
            HistoWoodieCCI[i] = EMPTY_VALUE;
         }
         prev = now;
      }

   }
   if(dt==Time[0]) return(0);
   dt = Time[0];
   if(HistoWoodieCCI[1] != EMPTY_VALUE)
   {
      if(UseAlert) Alert("Retrace Found :"+Symbol() + " @: "+Period());
      if(UseEmail) SendMail("Retrace Found","A Retrace was found with Symbol "+Symbol()+" at Timeframe "+Period());
   }
   return(0);
  }

